#include "random.h"

static Random rnd;
static long rnd_seed = -1;

Real vdm_MATH_acos(const Real &r)
{
  return Real (acos (r.GetValue ()));
}


Bool vdm_MATH_pre_acos(const Real &r)
{
  return Bool (fabs (r.GetValue ()) <= 1.0);
}


Real vdm_MATH_asin(const Real &r)
{
  return Real (asin (r.GetValue ()));
}


Bool vdm_MATH_pre_asin(const Real &r)
{
  return Bool (fabs (r.GetValue ()) <= 1.0);
}


Real vdm_MATH_atan(const Real &r)
{
  return Real (atan (r.GetValue ()));
}


Real vdm_MATH_cos(const Real &r)
{
  return Real (cos (r.GetValue ()));
}


Bool vdm_MATH_post_cos(const Real &r1, const Real &r2)
{
  return Bool (fabs (r2.GetValue ()) <= 1.0);
}


Real vdm_MATH_cot(const Real &r)
{
  return Real ( 1.0/tan (r.GetValue()));
}


Real vdm_MATH_pi_uf()
{
  return Real (vdm_MATH_pi);
}


Real vdm_MATH_sin(const Real &r)
{
  return Real (sin (r.GetValue ()));
}


Bool vdm_MATH_post_sin(const Real &r1, const Real &r2)
{
  return Bool (fabs (r2.GetValue ()) <= 1.0);
}


Real vdm_MATH_sqrt(const Real &r)
{
  return Real (sqrt (r.GetValue ()));
}


Bool vdm_MATH_pre_sqrt(const Real &r)
{
  return Bool (r.GetValue () >= 0.0);
}


Real vdm_MATH_tan(const Real &r)
{
  return Real (tan (r.GetValue ()));
}


Int vdm_MATH_srand2(const Int &r)
{
  rnd_seed = r.GetValue();
  if( rnd_seed >= 0 )
  {
    rnd.set_seed(r.GetValue());
  }
  return r;
}


Bool vdm_MATH_pre_srand2(const Int &r)
{
  return Bool (r.GetValue () >= -1);
}


Int vdm_MATH_rand(const Int &r)
{
  if( rnd_seed >= 0 )
  {
    return Int(rnd.get_random(r.GetValue()));
  }
  else
  {
    return r;
  }
}


Real vdm_MATH_exp(const Real &r)
{
  return Real (exp (r.GetValue ()));
}


Real vdm_MATH_ln(const Real &r)
{
  return Real (log (r.GetValue ()));
}


Bool vdm_MATH_pre_ln(const Real &r)
{
  return Bool (r.GetValue () > 0.0);
}


Real vdm_MATH_log(const Real &r)
{
  return Real (log10 (r.GetValue ()));
}


Bool vdm_MATH_pre_log(const Real &r)
{
  return Bool (r.GetValue () > 0.0);
}


